//*****************************************
// AVR ATtiny13A Dekatron(OG-3) Check Program
// CPU Clock:9.6MHz
//   iq[Yf[^@UXDUlgɂj
//
// File Name:og3_spinner.c
// 
// fJg nf|R̓`FbNvO
//
// dnm XCb`ĂƓxiKCh̃pXȂj
//
//@J
//@@u`uq@r@SDPWv{roR
//@@bRpCFuv`uqviv`uq|QOOPPO|DŃCXg[j
//@@ݑuF`uqhro@U
//
//  2016/08/30 New(TAB4)  Taishi
//  2016/10/03 Modify     Taishi dnmŃXCb`܂ŘA̐t݈ړ𑱂
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/io.h>

#include	"og3_spinner.h"
#include	"Timer.h"
#include	"port_bit.h"
#include	"dekatron.h"

unsigned char	slow = 0;

//***************************
// A]
//***************************
static	void	renzoku(void)
{
	unsigned char	direction = 0;
	unsigned char	uc;
	unsigned char	syuki = 100;		// ړԊu@x10mS
	unsigned char	mode = 0;			// OFAPF葬AQF
	unsigned char	count = 0;			// ōł̈ړ

	tim_10ms_led = 0;									// ړɗp

	while(1){
		uc = get_action_sw();							// XCb`Ԃ
		if(uc == SWR_OFF_SHORT){						// Zꂽ
			break;
		}else if(uc == SWR_OFF_LONG){					// 
			slow = 1;									// x
			break;
		}

		if(tim_10ms_led == 0){
			tim_10ms_led = syuki;
			move_one(direction);						// ړ
			if(mode == 0){								// ̎
				if(20 < syuki){
					syuki -= 10;
				}else if(2 < syuki){
					syuki--;
				}else{
					syuki = 2;
					mode = 1;
					count = 40;
				}
			}else if(mode == 1){						// 葬̎
				count--;
				if(count == 0){
					mode = 2;
				}
			}else{
				if(100 < syuki){
					mode = 0;
					direction ^= 1;						// ]ύX
				}else if(20 < syuki){
					syuki += 10;
				}else{
					syuki++;
				}
			}
		}
	}

}
//***************************
// Main
//***************************
int	main(void)
{
	unsigned char	direction = 0;
	unsigned char	uc;

	delay_ms(200);										// 200mS Delay

	sw_init();											// XCb`̏ݒ
	timer0_init();										// Timer0 Initial
	led_init();
	move_init();										// ړi]j̏ݒ


#ifdef	DEBUG
	slow = 1;											// x
#endif

	for(uc=0;uc<5;uc++){
		led_on_off(1);									// LEDON
		delay_ms(250);									// 250mS Delay
		led_on_off(0);									// LEDOFF
		delay_ms(250);									// 250mS Delay
	}

	sei();

	renzoku();											// A]

	direction = 0;										// ] ]
	tim_10ms_led = 0;

	while(1){
		uc = get_action_sw();							// XCb`Ԃ
		if(uc == SWR_OFF_SHORT){						// Zꂽ
			move_one(direction);						// ړ
			tim_10ms_led = 10;							// kdc@nm
		}else if(uc == SWR_OFF_LONG){					// 
			direction ^= 1;								// ]ύX
		}else if((uc & SWR_ON_CONTINUE) != 0){			// ꑱ
			move_one(direction);						// ړ
			tim_10ms_led = 10;							// kdc@nm
		}

		if(tim_10ms_led == 0){
			led_on_off(0);								// LEDOFF
		}else{
			led_on_off(1);								// LEDON
		}
	}
}
